<?php
// $Id: search.class.php,v 1.00 2007/05/30 14:23:23 yoshis Exp $
//  ------------------------------------------------------------------------ //
//                        newbb_fileup for XOOPS                             //
//                    Copyright (c) 2007 Bluemoon inc.                       //
//                     <http://www.bluemooninc.biz/>                         //
//  ------------------------------------------------------------------------ //
//  This program is free software; you can redistribute it and/or modify     //
//  it under the terms of the GNU General Public License as published by     //
//  the Free Software Foundation; either version 2 of the License, or        //
//  (at your option) any later version.                                      //
//                                                                           //
//  You may not change or alter any portion of this comment or credits       //
//  of supporting developers from this source code or any supporting         //
//  source code which is considered copyrighted (c) material of the          //
//  original comment or credit authors.                                      //
//                                                                           //
//  This program is distributed in the hope that it will be useful,          //
//  but WITHOUT ANY WARRANTY; without even the implied warranty of           //
//  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the            //
//  GNU General Public License for more details.                             //
//                                                                           //
//  You should have received a copy of the GNU General Public License        //
//  along with this program; if not, write to the Free Software              //
//  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307 USA //
//  ------------------------------------------------------------------------ //
// Author: Yoshi Sakai                                                       //
// URL: //www.bluemooninc.biz/                                               //
// ------------------------------------------------------------------------- //
class search {
	var $terms = array();
	var $mb_suggest_w = array();
	var $andor = "OR";
	var $addquery = "";
	var $subquery = "";
	var $term4disp = "";
	function search( $term ){
		$this->term4disp = htmlspecialchars( $term , ENT_QUOTES ) ;
		$term4sql = addslashes( $term ) ;
		if( defined( '_MD_NEWBB_MULTIBYTESPACES' ) ) {
			$term4sql = str_replace( explode( ',' , _MD_NEWBB_MULTIBYTESPACES ) , ' ' , $term4sql ) ;
		}
		$this->terms = explode( ' ' , $term4sql ) ;
	}
	function &terms(){
		return $this->terms;
	}
	function mb_suggest($q){
		if(function_exists('mb_convert_kana') && function_exists('mb_detect_encoding')){
			//for Japanese EUC-JP
			if ( mb_detect_encoding($q)=="EUC-JP"){
				if( preg_match(_MD_PREG_ZESU, $q) ){
					//Zenkaku Eisu
					return mb_convert_kana(addSlashes($q), 'a');
				}elseif(preg_match(_MD_PREG_ZKANA, $q)){
					//Zenkaku Katakana
					return mb_convert_kana(addSlashes($q), 'k');
				}elseif(preg_match(_MD_PREG_HKANA, $q)){
					//Hankaku Katakana
					return mb_convert_kana(addSlashes($q), 'KV');
				}
			}elseif(preg_match(_MD_PREG_HESU, $q)){
				//Hankaku Eisu
				return mb_convert_kana(addSlashes($q), 'A');
			}
		}
		return NULL;
	}
	/*
	** makeSuggestWords is currently Japanese only. 2007/05/30
	*/
	function makeSuggestWords(){
		$cnt = 0;
		foreach($this->terms as $t){
			$this->mb_suggest_w[$cnt] = $this->mb_suggest($t);
			$cnt++;
		}
	}
	function setKeywords($andor){
		// AND/OR relates to the ANY or ALL on Search Page
		$this->andor = $andor;
		$size = count($this->terms);
		for ( $i = 0; $i < $size; $i++ ) {
			$this->addquery .= $i==0 ? "(" : " $this->andor ";
			$this->subquery .= $i==0 ? "(" : " $this->andor ";
			if ( isset($this->mb_suggest_w[$i]) ){
				$this->addquery .= 
					"(pt.post_text LIKE '%".$this->terms[$i]."%' OR pt.post_text LIKE '%".$this->mb_suggest_w[$i]."%')";
				$this->subquery .= 
					"(t.topic_title LIKE '%".$this->terms[$i]."%' OR t.topic_title LIKE '%".$this->mb_suggest_w[$i]."%')";
			}else{
				$this->addquery .= "pt.post_text LIKE '%".$this->terms[$i]."%'";
				$this->subquery .= "t.topic_title LIKE '%".$this->terms[$i]."%'";
			}
		}
		$this->addquery .= ')';
		$this->subquery .= ')';
	}
	function forumChoice($forum){
		if ($forum !='all' ) {
			if ( isset($this->addquery) ) {
				$this->addquery .= ' AND ';
				$this->subquery .= ' AND ';
			}
			$this->addquery .= ' p.forum_id='.$forum;
			$this->subquery .= ' p.forum_id='.$forum;
		}
	}
	function userName($search_username){
		global $xoopsDB;
		if ( !$result = $xoopsDB->query("SELECT uid FROM ".$xoopsDB->prefix("users")
			." WHERE uname='$search_username'") ) {
			redirect_header('search.php',1,_MD_ERROROCCURED);
			exit();
		}
		$row = $xoopsDB->fetchArray($result);
		if ( !$row ) {
			redirect_header('search.php',1,_MD_USERNOEXIST);
			exit();
		}
		if ( isset($this->addquery) ) {
			$this->addquery .= " AND p.uid=".$row['uid'];
			$this->subquery .= " AND p.uid=".$row['uid'];
		} else {
			$this->addquery .= " p.uid=".$row['uid'];
			$this->subquery .= " p.uid=".$row['uid'];
		}
	}
	function where( $searchboth ){
		if ( isset($this->addquery) ) {
			switch (@$searchboth ) {
			case 'both':
				$query = " WHERE (($this->subquery) OR ($this->addquery)) AND ";
			    break;
			case 'title':
				$query = " WHERE ($this->subquery) AND ";
				break;
			case 'text':
			default:
				$query = " WHERE ($this->addquery) AND ";
				break;
			}
		} else {
			$query = ' WHERE ';
		}
		return $query;
	}
}
?>
